<!DOCTYPE html>
<html lang="en">

<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>


</head>

<body>

  <div class="container">
    <h2 style="text-align: center;">Danh sách người dùng</h2>
    <div class="form-group">
      <button class="btn btn-success" id="btn-add-user"><i class="fa fa-plus"></i>&nbsp; Thêm người dùng</button>
    </div>
    <table id="user-table" class="table table-bordered table-striped table-hover">
      <thead>
        <tr>
          <th>Mã người dùng</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Country</th>
          <th>Subject</th>
          <th>Customer Type</th>
          <th>Register Status</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>

      </tbody>
    </table>

    <!-- Vùng Modal -->

    <!-- Create voucher modal -->
    <div>
      <div id="create-user-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="h5-modal-title">Create new User</h5>
              <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
              <form>
                <div class="row form-group">
                  <label class="col-sm-4">Firstname</label>
                  <input class="col-sm-8 form-control" type="text" id="inp-create-firstname">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Lastname</label>
                  <input class="col-sm-8 form-control" type="text" id="inp-create-lastname">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Subject</label>
                  <input class="col-sm-8 form-control" type="text" id="inp-create-subject">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Country</label>
                  <select class="col-sm-8 form-control" id="select-create-country">
                    <option value="VN">Việt Nam</option>
                    <option value="USA">USA</option>
                    <option value="AUS">Australia</option>
                    <option value="CAN">Canada</option>
                  </select>
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Customer Type</label>
                  <select class="col-sm-8 form-control" id="select-create-type">
                    <option value="Standar">Standar</option>
                    <option value="Gold">Gold</option>
                    <option value="Premium">Premium</option>
                  </select>
                </div>
                <!-- <div class="row form-group">
                  <label class="col-sm-4">Register Status</label>
                  <select class="col-sm-8 form-control" id="select-create-status">
                    <option value="New">New</option>
                    <option value="Accepted">Accepted</option>
                    <option value="Denied">Denied</option>
                  </select>
                </div> -->
              </form>
            </div>
            <div class="modal-footer">
              <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
              <button class="btn btn-primary" id="btn-create-user">Create Voucher</button>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- Update voucher modal -->
    <div>
      <div id="update-user-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="h5-modal-title">Update a User</h5>
              <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
              <form>
                <div class="row form-group">
                  <label class="col-sm-4">Firstname</label>
                  <input class="col-sm-8 form-control" type="text" id="inp-update-firstname">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Lastname</label>
                  <input class="col-sm-8 form-control" type="text" id="inp-update-lastname">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Subject</label>
                  <input class="col-sm-8 form-control" type="text" id="inp-update-subject">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Country</label>
                  <select class="col-sm-8 form-control" id="select-update-country">
                    <option value="VN">Việt Nam</option>
                    <option value="USA">USA</option>
                    <option value="AUS">Australia</option>
                    <option value="CAN">Canada</option>
                  </select>
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Customer Type</label>
                  <select class="col-sm-8 form-control" id="select-update-type">
                    <option value="Standar">Standar</option>
                    <option value="Gold">Gold</option>
                    <option value="Premium">Premium</option>
                  </select>
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Register Status</label>
                  <select class="col-sm-8 form-control" id="select-update-status">
                    <option value="New">New</option>
                    <option value="Accepted">Accepted</option>
                    <option value="Denied">Denied</option>
                  </select>
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Cancel</button>
              <button class="btn btn-primary" id="btn-update-user">Update Voucher</button>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- Delete confirm modal -->
    <div>
      <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="h5-modal-title">User Delete Confirmation</h5>
              <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
              <label>Bạn có chắc chắn muốn xóa User này không?</label>
            </div>
            <div class="modal-footer">
              <button class="btn btn-danger" id="btn-confirm-delete-user">Confirm</button>
              <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  ​
  <script>


    $(document).ready(function () {
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      const gREQUEST_STATUS_OK = 200;
      const gREQUEST_STATUS_DELETE_OK = 204;
      const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
      const gREQUEST_STATUS_CREATE_OK = 201;
      const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
      var gUserObj = {
        "firstname": "",
        "lastname": "",
        "country": "",
        "subject": "",
        "customerType": "",
        "registerStatus": "",
      }
      var gUserId = 0;
      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
      onPageLoading();


      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      function onPageLoading() {
        //load data list table
        loadDataListTable()
        //gui Api lay du lieu vao table
        getDataUser();
        //click button add
        $("#btn-add-user").on("click", function () {
          //show modal create
          $("#create-user-modal").modal("show");
        })
        //hàm xử lý khi xác nhận thêm dữ liệu người dùng mới
        $("#btn-create-user").on("click", function () {
          //thêm dữ liệu form vào Obj
          addDataToObj(gUserObj);
          //validate du lieu
          if (checkDataToObj(gUserObj)) {
            console.log(gUserObj);
            //gui Api them du lieu
            sendApiCreateUser();
          }

        })

        //click button update
        $("#user-table").on("click", ".edit-user", function () {
          //load du lieu vao form update
          var vUserRow = clickButtonDetail(this)
          addDataToFormUpdate(vUserRow);
          //show modal update
          $("#update-user-modal").modal("show");

        })

        //click button xac nhan update
        $("#btn-update-user").on("click", function () {
          //load du lieu tu form vao Obj
          addDataUpdateToObj(gUserObj);
          //validate du lieu
          if (checkDataToObj(gUserObj)) {
            //gui Api update user
            sendApiUpdateUSer(gUserId);
          }
        })

        //click button xoa
        $("#user-table").on("click", ".delete-user", function () {
          //hien modal xac nhan xoa
          $("#delete-confirm-modal").modal("show");
          //gan du lieu id user
          clickButtonDetail(this);
        })
        //click xác nhận xóa User
        $("#btn-confirm-delete-user").on("click", function () {
          //gui api xoa user
          sendApiDeleteUSer(gUserId);
        })
      }

      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      //ham load data list to table
      function loadDataListTable() {
        var vNameCol = [
          "id",
          "firstname",
          "lastname",
          "country",
          "subject",
          "customerType",
          "registerStatus",
          "action"
        ];
        /* add JSON data vào DataTable sử dụng add trực tiếp DataTable row */
        $("#user-table").DataTable({
          columns: [
            { data: vNameCol[0] },
            { data: vNameCol[1] },
            { data: vNameCol[2] },
            { data: vNameCol[3] },
            { data: vNameCol[4] },
            { data: vNameCol[5] },
            { data: vNameCol[6] },
            { data: vNameCol[7] },
          ],
          columnDefs: [
            {
              targets: 7,
              className: "text-center",
              defaultContent: `
                <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
              `
            }
          ],
        })
      }
      //gui Api lay du lieu
      function getDataUser() {
        $("#user-table").find('tbody tr').remove();
        $.ajax({
          url: gBASE_URL,
          type: 'GET',
          dataType: 'json',								// kiểu dữ liệu (thường dùng khi muốn nhận dữ liệu từ server)
          async: false,									//không có thì mặc định là true 
          success: function (res) {
            console.log(res);							// dữ liệu đã được xử lý sang array
            //them du lieu vao table
            insertDataTable(res);
          },
          error: function (ajaxContext) {
            alert(ajaxContext.responseText)
          }
        });
      }
      //gui Api them du lieu user
      function sendApiCreateUser() {
        $.ajax({
          url: gBASE_URL,
          type: 'POST',
          contentType: 'application/json',
          data: JSON.stringify(gUserObj),
          async: true,
          success: function (res) {
            console.log(res);
            //xu ly fronend
            handleInsertUserSuccess();
          },
          error: function (ajaxContext) {
            alert(ajaxContext.responseText)
          }
        });
      }
      //gui Api update user
      function sendApiUpdateUSer(vId) {
        $.ajax({
          url: gBASE_URL + vId,
          type: 'PUT',
          contentType: 'application/json',
          data: JSON.stringify(gUserObj),
          async: true,
          success: function (res) {
            console.log(res);
            //xu ly fronend
            handleUpdateUserSuccess();
          },
          error: function (ajaxContext) {
            alert(ajaxContext.responseText)
          }
        });
      }
      //gui Api xoa user
      function sendApiDeleteUSer(vId) {

        $.ajax({
          url: gBASE_URL + vId,
          type: 'DELETE',
          contentType: 'application/json',
          async: true,
          success: function (res) {
            //xu ly fronend
            handleDeleteUserSuccess();
          },
          error: function (ajaxContext) {
            alert(ajaxContext.responseText)
          }
        });
      }
      //thêm đữ liệu vào table
      function insertDataTable(vUserObj) {
        var vTable = $("#user-table").DataTable();
        vTable.clear();
        vTable.rows.add(vUserObj);
        vTable.draw();
      }
      //ham click button detail gan du lieu Id
      function clickButtonDetail(paramElement) {
        var vRowClick = $(paramElement).closest("tr");
        var vTable = $("#user-table").DataTable();
        var vDataRow = vTable.row(vRowClick).data();
        console.log(vDataRow);
        gUserId = vDataRow.id;
        return vDataRow;
      }
      //them du lieu tu form vao Obj
      function addDataToObj(paramObj) {
        paramObj.firstname = $("#inp-create-firstname").val();
        paramObj.lastname = $("#inp-create-lastname").val();
        paramObj.subject = $("#inp-create-subject").val();
        paramObj.country = $("#select-create-country").val();
        paramObj.customerType = $("#select-create-type").val();
        // paramObj.registerStatus =  "New";
      }
      //validate du lieu form
      function checkDataToObj(paramObj) {
        if (paramObj.firstname == "") {
          alert("First Name khong duoc de trong.");
          return false;
        }

        if (paramObj.lastname == "") {
          alert("Last Name khong duoc de trong.");
          return false;
        }

        if (paramObj.subject == "") {
          alert("Subject khong duoc de trong.");
          return false;
        }

        return true;
      }
      //them du lieu tu obj vao form update
      function addDataToFormUpdate(vDataRow) {
        //load du lieu vao form
        $("#inp-update-firstname").val(vDataRow.firstname);
        $("#inp-update-lastname").val(vDataRow.lastname);
        $("#inp-update-subject").val(vDataRow.subject);
        $("#select-update-country").val(vDataRow.country);
        $("#select-update-type").val(vDataRow.customerType);
        $("#select-update-status").val(vDataRow.registerStatus);

      }
      //them du lieu tu form update vao Obj
      function addDataUpdateToObj(paramObj) {
        //them du lieu vao userObj
        paramObj.firstname = $("#inp-update-firstname").val();
        paramObj.lastname = $("#inp-update-lastname").val();
        paramObj.subject = $("#inp-update-subject").val();
        paramObj.country = $("#select-update-country").val();
        paramObj.customerType = $("#select-update-type").val();
        paramObj.registerStatus = $("#select-update-status").val();
      }

      // hàm xử lý hiển thị front-end khi thêm user thành công
      function handleInsertUserSuccess() {
        alert("Thêm nguoi dung thành công!");
        //load lai du lieu vao table
        getDataUser();
        //xoa du lieu form
        $("#inp-create-firstname").val("");
        $("#inp-create-lastname").val("");
        $("#inp-create-subject").val("");
        $("#select-create-country").val("");
        $("#select-create-type").val("");
        $("#select-create-status").val("");
        //hide modal
        $("#create-user-modal").modal("hide");
      }
      //hàm xử lý hiển thị front-end khi update user thành công
      function handleUpdateUserSuccess() {
        alert("Sua nguoi dung thành công!");
        //load lai du lieu vao table
        getDataUser();
        //hide modal
        $("#update-user-modal").modal("hide");
      }
      //hàm xử lý hiển thị front-end khi xoa user thành công
      function handleDeleteUserSuccess() {
        alert("Xoa nguoi dung thành công!");
        //load lai du lieu vao table
        getDataUser();
        //hide modal
        $("#delete-confirm-modal").modal("hide");
      }
    });

  </script>
</body>

</html>
​